<template>
    <div class="d-md-flex align-items-center justify-content-between flex-wrap p-2 pb-3 contenedorPrincipal">
        <div class="col-3 ms-3 mt-3">
            <label for="solicitante" class="form-label d-block">Solicitante:</label>
            <auto-complete class="d-inline mt-0" v-model="data.solicitante" :elements="solicitantesStore.solicitantes"
                initKey="" placeholder="Apellido/s y Nombre/s" :minLength="3" :disabled="false" id="solicitante" />

        </div>
        <div class="col-2 ms-3 mt-3">
            <label for="becario" class="form-label">Becario:</label>
            <auto-complete v-model="data.becario" :elements="becariosStore.becarios" initKey=""
                placeholder="Apellido/s y Nombre/s" :minLength="2" :disabled="false" id="becario" />
        </div>

        <div class="col-2 ms-3 mt-3">
            <label for="apoderado" class="form-label">Apoderado:</label>
            <auto-complete v-model="data.apoderado" :elements="becariosStore.becarios" initKey=""
                placeholder="Apellido/s y Nombre/s" :minLength="2" :disabled="false" id="apoderado" />
        </div>

        <div class="col-2 ms-3 mt-3">
            <label for="responsable" class="form-label">Responsable:</label>
            <auto-complete v-model="data.responsable" :elements="solicitantesStore.solicYProyectos" initKey=""
                placeholder="Responsable" :minLength="2" :disabled="false" id="responsable" />
        </div>

        <div class="col-2 ms-3 mt-3">
            <label for="bloque" class="form-label">Bloque Pol&iacute;tico:</label>
            <auto-complete v-model="data.bloque" :elements="bloquesStore.bloques" initKey="" placeholder="Dependencia"
                :minLength="2" :disabled="false" id="bloque" />
        </div>

        <div class="col-2 ms-3 mt-3">
            <label for="baproSucursal" class="form-label">Sucursal Bapro:</label>
            <auto-complete v-model="data.baproSucursal" :elements="baproSucursalesStore.getBaproSucursales()" initKey=""
                placeholder="Sucursal" :minLength="2" :disabled="false" id="baproSucursal" />
        </div>


        <!-- <div class="col-2 ms-3 mt-3">
            <label for="f_desde" class="form-label" style="margin-top: 2px !important">Periodo:</label>
            <input required type="date" v-model="data.f_desde" class="form-control" id="f_desde" autocomplete="off" />
        </div> -->

        <div class="col-2 ms-3 mt-3">
            <label for="liquidacion" class="form-label" style="margin-top: 2px !important">Liquidación:</label>
            <auto-complete required v-model="data.liquidaciones" :elements="liquidacionesStore.listadoLiquidaciones" initKey=""
                placeholder="Liquidación" :minLength="2" :disabled="false" id="liquidaciones" />
        </div>

        <div class="col-2 ms-3 mt-3">
            <label for="orden" class="form-label">Orden:</label>
            <select v-model="data.orden" class="form-select form-select-sm px-4" id="orden">
                <!-- <option :value="null" v-text="'--Seleccione--'"></option> -->
                <option :value="'A'" v-text="'Por Alfabeto'"></option>
                <option :value="'B'" v-text="'Por Bloque'"></option>
            </select>
        </div>
        <div class="col-4"></div>
        <div v-show="data.liquidaciones != null" class="col-12 ms-3 mt-3 text-end ">
            <!--             <button type="button" class="btn btn-principal px-3 mt-2" alt="Buscar Liquidaciones "
                title="Buscar liquidaciones" @click="buscarLiquidacion()">
                <i class="bi bi-search"></i>
            </button> -->
            <a :href="becasLiqImprimir(0)
                " target="_blank" title="Imprimir" alt="Imprimir" class="btn btn-principal p-1 px-2 mt-1">
                <i class="fa-solid fa-print me-1"></i> Imprimir PDF Detallado
            </a>
            <a :href="becasLiqImprimir(1)
                " target="_blank" title="Imprimir" alt="Imprimir" class="btn btn-principal mx-3 p-1 px-2 mt-1">
                <i class="fa-solid fa-print me-1"></i> Imprimir PDF Totales
            </a>
            <!-- <a :href="becasLiqImprimirExel()
                " target="_blank" title="Imprimir" alt="Imprimir" class="btn btn-principal  p-1 px-2 mt-1">
                <i class="fa-solid fa-table me-1"></i> Excel
            </a> -->
            <button class="btn btn-principal px-3 mt-2 mx-2" alt="BLimpiar" title="Limpiar" @click="limpiarFormulario()">
                <i class="fs-6 p-2 px-0 fa-solid fa-broom"></i>

            </button>
        </div>
    </div>
</template>

<script setup lang="ts">
// Librerias
import { DateTime } from "luxon";
import { onMounted, reactive, computed, ref } from "vue";

import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions } from "sweetalert2";

//import type { PropType } from "vue";
import { loading, isEmpty, getUrl } from "@/shared.js";
import { AutoComplete, Modal } from "@hcd-bsas/vue3-components";

// Componentes
// Entidades
import Solicitante from "@/entities/Solicitante";
import type Becario from "@/entities/becas/Becario";
import type Bloque from "@/entities/Bloque";
import type BaproSucursal from "@/entities/becas/BaproSucursal";
import type Liquidacion from "@/entities/Liquidaciones/Liquidacion";

// Stores
import { useSolicitantesStore } from "@/stores/solicitantes";
import { useLiqBecasCabeceraStore } from "@/stores/Liquidaciones/cabeceraBecas";
import { useBecariosStore } from "@/stores/becas/becarios";
import { useBloquesStore } from "@/stores/bloques";
import { useBaproSucursalesStore } from "@/stores/becas/baproSucursales";
import { useLiquidacionesStore } from "@/stores/Liquidaciones/liquidaciones";

const solicitantesStore = useSolicitantesStore();
const liqBecasCabeceraStore = useLiqBecasCabeceraStore();
const becariosStore = useBecariosStore();
const bloquesStore = useBloquesStore();
const baproSucursalesStore = useBaproSucursalesStore();
const liquidacionesStore = useLiquidacionesStore();


var data = reactive({
    solicitante: null as Solicitante | null,
    /*f_desde: null as String | null, */
    /* f_hasta: null as String | null, */
    becario: undefined as Becario | undefined,
    apoderado: undefined as Becario | undefined,
    bloque: undefined as Bloque | undefined,
    baproSucursal: undefined as BaproSucursal | undefined,
    responsable: undefined as Solicitante | undefined,
    liquidaciones: undefined as Liquidacion | undefined,
    orden: 'A' as String,


});

/* const fechaMostrar = (fecha: string | null) =>
    fecha !== null ? DateTime.fromISO(fecha).toFormat("dd/MM/yyyy") : "";
const valFDesde = computed(() => !isEmpty(data.f_desde));
const valFHasta = computed(() => !isEmpty(data.f_hasta));

const cuposTitulo = computed(
    () =>
        'Cupos del solicitante "' +
        data.solicitante?.ayn +
        '"' +
        " desde el " +
        fechaMostrar(String(data.f_desde)) +
        " hasta el " +
        fechaMostrar(String(data.f_hasta))
); */

/*const cuposParametros = computed(() => ({
    f_cupo_des: data.f_desde,
    f_cupo_has: data.f_hasta,
    id_tabla_sol: data.solicitante?.id_tabla_sol,
    usar_perfil_consulta: 0,
})); */


onMounted(async () => {
    liqBecasCabeceraStore.listadoInformeLiq = [];
    loading.show();
    await cargar();
    loading.hide();
});



function limpiarFormulario() {
    /* const fechaActual = new Date(); */
    /* const anioActual = fechaActual.getFullYear(); */
    /* data.f_desde = anioActual + "-03-01"; */
    /*  data.f_hasta = anioActual + "-12-31"; */

    data.bloque = undefined;
    data.solicitante = null;
    data.becario = undefined;
    data.apoderado = undefined;
    data.baproSucursal = undefined;
    data.responsable = undefined;
    data.liquidaciones = undefined;

}

async function cargar() {

   /*  const fechaActual = new Date(); */
/*     const anioActual = fechaActual.getFullYear();
    data.f_desde = anioActual + '-03-01'; */

    await Promise.all([
        solicitantesStore.fetchSolicYProyectos(),
        becariosStore.fetchBecarios(),
        bloquesStore.fetchBloques(),
        baproSucursalesStore.fetchBaproSucursales(),
        liquidacionesStore.updateListadoLiquidaciones()
    ])


}

function becasLiqImprimir(detallado: number) {
    var queryParams: any = {
        id_tabla_sol: isEmpty(data.solicitante) ? null : data.solicitante?.id_tabla_sol,
        id_becario: isEmpty(data.becario?.id_becario) ? null : data.becario?.id_becario,
        id_apoderado: isEmpty(data.apoderado?.id_apoderado) ? null : data.apoderado?.id_apoderado,
        id_responsable: isEmpty(data.responsable?.id_tabla_sol_responsable) ? null : data.responsable?.id_tabla_sol_responsable,
        baprosuc: isEmpty(data.baproSucursal) ? null : data.baproSucursal,
        id_beca: null,
        id_dependen: null,
        usar_perfil_consulta: 0,
        id_liq_resu: isEmpty(data.liquidaciones) ? null : data.liquidaciones?.id_liq_resu,
        orden: data.orden,
        detallado: detallado,


    }
     return getUrl('imprimirBecasLiquidadas', [], queryParams);

}

function becasLiqImprimirExel() {
    /*var queryParams: any = {
             id_tabla_sol: isEmpty(props.parametros.solicitante) ? null : props.parametros.solicitante?.id_tabla_sol,
            id_becario: isEmpty(props.parametros.becario?.id_becario) ? null : props.parametros.becario?.id_becario,
            id_apoderado: isEmpty(props.parametros.apoderado?.id_apoderado) ? null : props.parametros.apoderado?.id_apoderado,
            id_bloque: isEmpty(props.parametros.bloque?.id_dependen) ? null : props.parametros.bloque?.id_dependen,
            f_desde: props.parametros.f_desde,
            f_hasta: props.parametros.f_hasta,
            id_expte: isEmpty(props.parametros.id_expte) ? null : props.parametros.id_expte,
            id_tabla_sol_responsable: isEmpty(props.parametros.responsable?.id_tabla_sol_responsable) ? null : props.parametros.responsable?.id_tabla_sol_responsable,
            baprosuc: isEmpty(props.parametros.baproSucursal) ? null : props.parametros.baproSucursal,
            id_beca: null,
            estado: props.parametros.estado,
            usar_perfil_consulta: 0,
            cond_visado: props.parametros.visado.id_visado,
            orden: props.parametros.orden, 
    }
    return getUrl('becasLiqImprimirExel', [], queryParams);*/

}

</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
